/*
 * sample.c -- sample program for decomp and solve
 */

#include <stdio.h>
#include "matutil.h"
#include "lu.h"

#define SIZE 10

int main(void)
{
    matrix a;
    double b[SIZE], work[SIZE], cond, condp1;
    int ipvt[SIZE], i, j, n;

    n = 3;	/* Of course n must be less than SIZE !! */
    a = new_matrix(SIZE, SIZE);
    a[0][0] = 10; a[1][0] = -3; a[2][0] =  5;
    a[0][1] = -7; a[1][1] =  2; a[2][1] = -1;
    a[0][2] = 0;  a[1][2] =  6; a[2][2] =  5;
    for (i = 0; i < n; i++) {
	for (j = 0; j < n; j++) {
	    printf("%8g", a[i][j]);
	    if (j % 5 == 4) printf("\n");
	}
	printf("\n");
    }
    printf("\n");
    decomp(n, a, &cond, ipvt, work);
    printf("cond=%15.5e\n", cond);
    printf("\n");
    condp1 = cond + 1;
    if (condp1 == cond) {
	printf("MATRIX IS SINGULAR TO WORKING PRECISION\n");
	return 0;
    }
    b[0] = 7;
    b[1] = 4;
    b[2] = 6;
    for (i = 0; i < n; i++) printf("%8g\n", b[i]);
    printf("\n");
    solve(n, a, b, ipvt);
    for (i = 0; i < n; i++) printf("%8g\n", b[i]);
    return 0;
}
