/*
 * sample1.c -- sample program for decomp1() and solve1()
 */

#include <stdio.h>
#include "matutil.h"
#include "lu1.h"

#define SIZE 10

int main(void)
{
    matrix a;
    double b[SIZE+1], work[SIZE+1], cond, condp1;
    int ipvt[SIZE+1], i, j, n;

    n = 3;  /* Of course n must be less than SIZE !! */
    a = new_matrix(n+1, n+1);
    a[1][1] = 10; 
    a[2][1] = -3; 
    a[3][1] =  5;
    a[1][2] = -7; 
    a[2][2] =  2; 
    a[3][2] = -1;
    a[1][3] = 0;  
    a[2][3] =  6; 
    a[3][3] =  5;
    for (i = 1; i <= n; i++) {
        for (j = 1; j <= n; j++) {
            printf("%7.2f", a[i][j]);
            if (j % 5 == 4) printf("\n");
        }
        printf("\n");
    }
    printf("\n");
    decomp1(n, a, &cond, ipvt, work);
    printf("cond=%15.5e\n", cond);
    printf("\n");
    condp1 = cond + 1;
    if (condp1 == cond) {
        printf("MATRIX IS SINGULAR TO WORKING PRECISION\n");
        return 0;
    }
    b[1] = 7;
    b[2] = 4;
    b[3] = 6;
    for (i = 1; i <= n; i++) printf("%7.2f\n", b[i]);
    printf("\n");
    solve1(n, a, b, ipvt);
    for (i = 1; i <= n; i++) printf("%7.2f\n", b[i]);
    return 0;
}
